diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/rate-control/rrpaa-wifi-manager.cc ns-3.38/src/wifi/model/rate-control/rrpaa-wifi-manager.cc
--- ns-3.37/src/wifi/model/rate-control/rrpaa-wifi-manager.cc	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/rate-control/rrpaa-wifi-manager.cc	2023-03-16 20:54:23.864869400 -0700
@@ -220,7 +220,7 @@
 RrpaaWifiManager::GetThresholds(RrpaaWifiRemoteStation* station, WifiMode mode) const
 {
     NS_LOG_FUNCTION(this << station << mode);
-    struct WifiRrpaaThresholds threshold;
+    WifiRrpaaThresholds threshold;
     for (RrpaaThresholdsTable::const_iterator i = station->m_thresholds.begin();
          i != station->m_thresholds.end();
          i++)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/rate-control/rrpaa-wifi-manager.h ns-3.38/src/wifi/model/rate-control/rrpaa-wifi-manager.h
--- ns-3.37/src/wifi/model/rate-control/rrpaa-wifi-manager.h	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/rate-control/rrpaa-wifi-manager.h	2023-03-16 20:54:23.864869400 -0700
@@ -37,7 +37,7 @@
  * Threshold Coordinated Management for High-Density IEEE 802.11 Networks</i>
  * by Matías Richart; Jorge Visca and Javier Baliosian in Integrated Network Management (IM),
  * 2015 IFIP/IEEE International Symposium on (pp. 139-146). IEEE.
- * http://dl.ifip.org/db/conf/im/im2015/137430.pdf
+ * https://ieeexplore.ieee.org/document/7140286
  *
  * RRPAA adds power control to the RRAA mechanism. RRAA is described in
  * <i>Robust rate adaptation for 802.11 wireless networks</i> by Starsky H. Y. Wong;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/rate-control/thompson-sampling-wifi-manager.cc ns-3.38/src/wifi/model/rate-control/thompson-sampling-wifi-manager.cc
--- ns-3.37/src/wifi/model/rate-control/thompson-sampling-wifi-manager.cc	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/rate-control/thompson-sampling-wifi-manager.cc	2023-03-16 20:54:23.864869400 -0700
@@ -350,7 +350,7 @@
         GetNumberOfAntennas(),
         nss,
         0, // NESS
-        GetChannelWidthForTransmission(mode, channelWidth),
+        GetPhy()->GetTxBandwidth(mode, channelWidth),
         GetAggregation(station),
         false);
 }
@@ -365,7 +365,6 @@
     // Use the most robust MCS for the control channel.
     auto& stats = station->m_mcsStats.at(0);
     WifiMode mode = stats.mode;
-    uint16_t channelWidth = std::min(stats.channelWidth, GetPhy()->GetChannelWidth());
     uint8_t nss = stats.nss;
 
     // Make sure control frames are sent using 1 spatial stream.
@@ -379,7 +378,7 @@
         GetNumberOfAntennas(),
         nss,
         0, // NESS
-        GetChannelWidthForTransmission(mode, channelWidth),
+        GetPhy()->GetTxBandwidth(mode, stats.channelWidth),
         GetAggregation(station),
         false);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/reduced-neighbor-report.cc ns-3.38/src/wifi/model/reduced-neighbor-report.cc
--- ns-3.37/src/wifi/model/reduced-neighbor-report.cc	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/reduced-neighbor-report.cc	2023-03-16 20:54:23.864869400 -0700
@@ -179,7 +179,7 @@
         startingFreq = 5000;
         break;
     case WIFI_PHY_BAND_6GHZ:
-        startingFreq = 5940;
+        startingFreq = 5950;
         break;
     case WIFI_PHY_BAND_UNSPECIFIED:
     default:
@@ -267,7 +267,7 @@
         startingFreq = 5000;
         break;
     case WIFI_PHY_BAND_6GHZ:
-        startingFreq = 5940;
+        startingFreq = 5950;
         break;
     case WIFI_PHY_BAND_UNSPECIFIED:
     default:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/spectrum-wifi-phy.cc ns-3.38/src/wifi/model/spectrum-wifi-phy.cc
--- ns-3.37/src/wifi/model/spectrum-wifi-phy.cc	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/spectrum-wifi-phy.cc	2023-03-16 20:54:23.864869400 -0700
@@ -210,8 +210,9 @@
                                               (primary80IsLower80 && phyIndex <= nRus / 2) ||
                                               (!primary80IsLower80 && phyIndex > nRus / 2));
                             HeRu::RuSpec ru(ruType, index, primary80);
-                            ru.SetPhyIndex(bw, GetOperatingChannel().GetPrimaryChannelIndex(20));
-                            NS_ABORT_IF(ru.GetPhyIndex() != phyIndex);
+                            NS_ABORT_IF(ru.GetPhyIndex(bw,
+                                                       GetOperatingChannel().GetPrimaryChannelIndex(
+                                                           20)) != phyIndex);
                             m_ruBands[channelWidth].insert({band, ru});
                         }
                     }
@@ -266,6 +267,12 @@
     }
 }
 
+bool
+SpectrumWifiPhy::CanStartRx(Ptr<const WifiPpdu> ppdu, uint16_t txWidth) const
+{
+    return GetLatestPhyEntity()->CanStartRx(ppdu, txWidth);
+}
+
 void
 SpectrumWifiPhy::StartRx(Ptr<SpectrumSignalParameters> rxParams)
 {
@@ -385,46 +392,38 @@
     // Do no further processing if signal is too weak
     // Current implementation assumes constant RX power over the PPDU duration
     // Compare received TX power per MHz to normalized RX sensitivity
-    uint16_t txWidth = wifiRxParams->ppdu->GetTransmissionChannelWidth();
+    const auto txWidth = wifiRxParams->txWidth;
+    const auto& ppdu = GetRxPpduFromTxPpdu(wifiRxParams->ppdu);
+    const auto& txVector = ppdu->GetTxVector();
     if (totalRxPowerW < DbmToW(GetRxSensitivity()) * (txWidth / 20.0))
     {
         NS_LOG_INFO("Received signal too weak to process: " << WToDbm(totalRxPowerW) << " dBm");
-        m_interference->Add(wifiRxParams->ppdu,
-                            wifiRxParams->ppdu->GetTxVector(),
-                            rxDuration,
-                            rxPowerW);
+        m_interference->Add(ppdu, txVector, rxDuration, rxPowerW);
         SwitchMaybeToCcaBusy(nullptr);
         return;
     }
 
-    // Unless we are receiving a TB PPDU, do not sync with this signal if the PPDU
-    // does not overlap with the receiver's primary20 channel
     if (wifiRxParams->txPhy)
     {
-        // if the channel width is a multiple of 20 MHz, then we consider the primary20 channel
-        uint16_t width = (GetChannelWidth() % 20 == 0 ? 20 : GetChannelWidth());
-        uint16_t p20MinFreq =
-            GetOperatingChannel().GetPrimaryChannelCenterFrequency(width) - width / 2;
-        uint16_t p20MaxFreq =
-            GetOperatingChannel().GetPrimaryChannelCenterFrequency(width) + width / 2;
-
-        if (!wifiRxParams->ppdu->CanBeReceived(p20MinFreq, p20MaxFreq))
+        if (!CanStartRx(ppdu, txWidth))
         {
-            NS_LOG_INFO("Cannot receive the PPDU, consider it as interference");
-            m_interference->Add(wifiRxParams->ppdu,
-                                wifiRxParams->ppdu->GetTxVector(),
-                                rxDuration,
-                                rxPowerW);
-            SwitchMaybeToCcaBusy(wifiRxParams->ppdu);
+            NS_LOG_INFO("Cannot start reception of the PPDU, consider it as interference");
+            m_interference->Add(ppdu, txVector, rxDuration, rxPowerW);
+            SwitchMaybeToCcaBusy(ppdu);
             return;
         }
     }
 
     NS_LOG_INFO("Received Wi-Fi signal");
-    Ptr<WifiPpdu> ppdu = wifiRxParams->ppdu->Copy();
     StartReceivePreamble(ppdu, rxPowerW, rxDuration);
 }
 
+Ptr<const WifiPpdu>
+SpectrumWifiPhy::GetRxPpduFromTxPpdu(Ptr<const WifiPpdu> ppdu)
+{
+    return GetPhyEntityForPpdu(ppdu)->GetRxPpduFromTxPpdu(ppdu);
+}
+
 Ptr<Object>
 SpectrumWifiPhy::GetAntenna() const
 {
@@ -448,10 +447,10 @@
 }
 
 void
-SpectrumWifiPhy::StartTx(Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector)
+SpectrumWifiPhy::StartTx(Ptr<const WifiPpdu> ppdu)
 {
     NS_LOG_FUNCTION(this << ppdu);
-    GetPhyEntity(ppdu->GetModulation())->StartTx(ppdu, txVector);
+    GetPhyEntity(ppdu->GetModulation())->StartTx(ppdu);
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/spectrum-wifi-phy.h ns-3.38/src/wifi/model/spectrum-wifi-phy.h
--- ns-3.37/src/wifi/model/spectrum-wifi-phy.h	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/spectrum-wifi-phy.h	2023-03-16 20:54:23.864869400 -0700
@@ -69,7 +69,7 @@
     ~SpectrumWifiPhy() override;
 
     // Implementation of pure virtual method.
-    void StartTx(Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector) override;
+    void StartTx(Ptr<const WifiPpdu> ppdu) override;
     Ptr<Channel> GetChannel() const override;
     uint16_t GetGuardBandwidth(uint16_t currentChannelWidth) const override;
     std::tuple<double, double, double> GetTxMaskRejectionParams() const override;
@@ -152,6 +152,14 @@
      */
     void Transmit(Ptr<WifiSpectrumSignalParameters> txParams);
 
+    /**
+     * Determine the WifiPpdu to be used by the RX PHY based on the WifiPpdu sent by the TX PHY.
+     *
+     * \param ppdu the WifiPpdu transmitted by the TX PHY
+     * \return the WifiPpdu to be used by the RX PHY
+     */
+    Ptr<const WifiPpdu> GetRxPpduFromTxPpdu(Ptr<const WifiPpdu> ppdu);
+
   protected:
     void DoDispose() override;
     void DoInitialize() override;
@@ -192,6 +200,17 @@
      */
     void UpdateInterferenceHelperBands();
 
+    /**
+     * Determine whether the PHY shall issue a PHY-RXSTART.indication primitive in response to a
+     * given PPDU.
+     *
+     * \param ppdu the PPDU
+     * \param txChannelWidth the channel width (MHz) used to transmit the PPDU
+     * \return true if the PHY shall issue a PHY-RXSTART.indication primitive in response to a PPDU,
+     * false otherwise
+     */
+    bool CanStartRx(Ptr<const WifiPpdu> ppdu, uint16_t txChannelWidth) const;
+
     Ptr<SpectrumChannel> m_channel; //!< SpectrumChannel that this SpectrumWifiPhy is connected to
 
     Ptr<WifiSpectrumPhyInterface> m_wifiSpectrumPhyInterface; //!< Spectrum PHY interface
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/sta-wifi-mac.cc ns-3.38/src/wifi/model/sta-wifi-mac.cc
--- ns-3.37/src/wifi/model/sta-wifi-mac.cc	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/sta-wifi-mac.cc	2023-03-16 20:54:23.864869400 -0700
@@ -714,6 +714,34 @@
     return m_state == WAIT_ASSOC_RESP;
 }
 
+std::set<uint8_t>
+StaWifiMac::GetSetupLinkIds() const
+{
+    if (!IsAssociated())
+    {
+        return {};
+    }
+
+    std::set<uint8_t> linkIds;
+    for (uint8_t linkId = 0; linkId < GetNLinks(); linkId++)
+    {
+        if (GetLink(linkId).bssid)
+        {
+            linkIds.insert(linkId);
+        }
+    }
+    return linkIds;
+}
+
+Mac48Address
+StaWifiMac::DoGetLocalAddress(const Mac48Address& remoteAddr) const
+{
+    auto linkIds = GetSetupLinkIds();
+    NS_ASSERT_MSG(!linkIds.empty(), "Not associated");
+    uint8_t linkId = *linkIds.begin();
+    return GetFrameExchangeManager(linkId)->GetAddress();
+}
+
 bool
 StaWifiMac::CanForwardPacketsTo(Mac48Address to) const
 {
@@ -773,8 +801,22 @@
                           // yet implemented (set it to 1 when implemented)
     }
 
-    hdr.SetAddr1(GetBssid(0)); // TODO use appropriate linkId
-    hdr.SetAddr2(GetAddress());
+    // the Receiver Address (RA) and the Transmitter Address (TA) are the MLD addresses only for
+    // non-broadcast data frames exchanged between two MLDs
+    auto linkIds = GetSetupLinkIds();
+    NS_ASSERT(!linkIds.empty());
+    uint8_t linkId = *linkIds.begin();
+    if (const auto apMldAddr = GetWifiRemoteStationManager(linkId)->GetMldAddress(GetBssid(linkId)))
+    {
+        hdr.SetAddr1(*apMldAddr);
+        hdr.SetAddr2(GetAddress());
+    }
+    else
+    {
+        hdr.SetAddr1(GetBssid(linkId));
+        hdr.SetAddr2(GetFrameExchangeManager(linkId)->GetAddress());
+    }
+
     hdr.SetAddr3(to);
     hdr.SetDsNotFrom();
     hdr.SetDsTo();
@@ -795,11 +837,12 @@
 StaWifiMac::Receive(Ptr<const WifiMpdu> mpdu, uint8_t linkId)
 {
     NS_LOG_FUNCTION(this << *mpdu << +linkId);
-    const WifiMacHeader* hdr = &mpdu->GetHeader();
+    // consider the MAC header of the original MPDU (makes a difference for data frames only)
+    const WifiMacHeader* hdr = &mpdu->GetOriginal()->GetHeader();
     Ptr<const Packet> packet = mpdu->GetPacket();
     NS_ASSERT(!hdr->IsCtl());
-    Mac48Address myAddr =
-        hdr->IsData() ? GetAddress() : GetFrameExchangeManager(linkId)->GetAddress();
+    Mac48Address myAddr = hdr->IsData() ? Mac48Address::ConvertFrom(GetDevice()->GetAddress())
+                                        : GetFrameExchangeManager(linkId)->GetAddress();
     if (hdr->GetAddr3() == myAddr)
     {
         NS_LOG_LOGIC("packet sent by us.");
@@ -825,7 +868,12 @@
             NotifyRxDrop(packet);
             return;
         }
-        if (hdr->GetAddr2() != GetBssid(0)) // TODO use appropriate linkId
+        std::set<Mac48Address> apAddresses; // link addresses of AP
+        for (auto id : GetSetupLinkIds())
+        {
+            apAddresses.insert(GetBssid(id));
+        }
+        if (apAddresses.count(mpdu->GetHeader().GetAddr2()) == 0)
         {
             NS_LOG_LOGIC("Received data frame not from the BSS we are associated with: ignore");
             NotifyRxDrop(packet);
@@ -835,7 +883,7 @@
         {
             if (hdr->IsQosAmsdu())
             {
-                NS_ASSERT(hdr->GetAddr3() == GetBssid(0)); // TODO use appropriate linkId
+                NS_ASSERT(apAddresses.count(mpdu->GetHeader().GetAddr3()) != 0);
                 DeaggregateAmsduAndForward(mpdu);
                 packet = nullptr;
             }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/sta-wifi-mac.h ns-3.38/src/wifi/model/sta-wifi-mac.h
--- ns-3.37/src/wifi/model/sta-wifi-mac.h	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/sta-wifi-mac.h	2023-03-16 20:54:23.864869400 -0700
@@ -25,11 +25,13 @@
 #include "mgt-headers.h"
 #include "wifi-mac.h"
 
+#include <set>
 #include <variant>
 
 class TwoLevelAggregationTest;
 class AmpduAggregationTest;
 class HeAggregationTest;
+class MultiLinkOperationsTestBase;
 
 namespace ns3
 {
@@ -127,6 +129,8 @@
     friend class ::AmpduAggregationTest;
     /// Allow test cases to access private members
     friend class ::HeAggregationTest;
+    /// Allow test cases to access private members
+    friend class ::MultiLinkOperationsTestBase;
 
     /// type of the management frames used to get info about APs
     using MgtFrameType =
@@ -203,6 +207,13 @@
     bool IsAssociated() const;
 
     /**
+     * Get the IDs of the setup links (if any).
+     *
+     * \return the IDs of the setup links
+     */
+    std::set<uint8_t> GetSetupLinkIds() const;
+
+    /**
      * Return the association ID.
      *
      * \return the association ID
@@ -290,6 +301,7 @@
 
     void Receive(Ptr<const WifiMpdu> mpdu, uint8_t linkId) override;
     std::unique_ptr<LinkEntity> CreateLinkEntity() const override;
+    Mac48Address DoGetLocalAddress(const Mac48Address& remoteAddr) const override;
 
     /**
      * Process the Beacon frame received on the given link.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/table-based-error-rate-model.cc ns-3.38/src/wifi/model/table-based-error-rate-model.cc
--- ns-3.37/src/wifi/model/table-based-error-rate-model.cc	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/table-based-error-rate-model.cc	2023-03-16 20:54:23.864869400 -0700
@@ -166,7 +166,8 @@
     else
     {
         NS_LOG_DEBUG("No MCS found for mode " << mode << ": use fallback error rate model");
-        return m_fallbackErrorModel->GetChunkSuccessRate(mode, txVector, snr, nbits, staId);
+        return m_fallbackErrorModel
+            ->GetChunkSuccessRate(mode, txVector, snr, nbits, numRxAntennas, field, staId);
     }
     bool ldpc = txVector.IsLdpc();
     NS_LOG_FUNCTION(this << +mcs << roundedSnr << size << ldpc);
@@ -181,7 +182,8 @@
     {
         NS_LOG_WARN("Table missing for MCS: "
                     << +mcs << " in TableBasedErrorRateModel: use fallback error rate model");
-        return m_fallbackErrorModel->GetChunkSuccessRate(mode, txVector, snr, nbits, staId);
+        return m_fallbackErrorModel
+            ->GetChunkSuccessRate(mode, txVector, snr, nbits, numRxAntennas, field, staId);
     }
 
     auto errorTable = (ldpc ? AwgnErrorTableLdpc1458
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/threshold-preamble-detection-model.cc ns-3.38/src/wifi/model/threshold-preamble-detection-model.cc
--- ns-3.37/src/wifi/model/threshold-preamble-detection-model.cc	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/threshold-preamble-detection-model.cc	2023-03-16 20:54:23.864869400 -0700
@@ -40,7 +40,7 @@
             .SetGroupName("Wifi")
             .AddConstructor<ThresholdPreambleDetectionModel>()
             .AddAttribute("Threshold",
-                          "Preamble is successfully detection if the SNR is at or above this value "
+                          "Preamble is successfully detected if the SNR is at or above this value "
                           "(expressed in dB).",
                           DoubleValue(4),
                           MakeDoubleAccessor(&ThresholdPreambleDetectionModel::m_threshold),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/txop.cc ns-3.38/src/wifi/model/txop.cc
--- ns-3.37/src/wifi/model/txop.cc	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/txop.cc	2023-03-16 20:54:23.864869400 -0700
@@ -68,8 +68,8 @@
                 "The minimum values of the contention window for all the links",
                 TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
                 AttributeContainerValue<UintegerValue>(),
-                MakeAttributeContainerAccessor<IntegerValue, std::list>(&Txop::SetMinCws,
-                                                                        &Txop::GetMinCws),
+                MakeAttributeContainerAccessor<UintegerValue, std::list>(&Txop::SetMinCws,
+                                                                         &Txop::GetMinCws),
                 MakeAttributeContainerChecker<UintegerValue>(MakeUintegerChecker<uint32_t>()))
             .AddAttribute("MaxCw",
                           "The maximum value of the contention window (just for the first link, "
@@ -84,8 +84,8 @@
                 "The maximum values of the contention window for all the links",
                 TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
                 AttributeContainerValue<UintegerValue>(),
-                MakeAttributeContainerAccessor<IntegerValue, std::list>(&Txop::SetMaxCws,
-                                                                        &Txop::GetMaxCws),
+                MakeAttributeContainerAccessor<UintegerValue, std::list>(&Txop::SetMaxCws,
+                                                                         &Txop::GetMaxCws),
                 MakeAttributeContainerChecker<UintegerValue>(MakeUintegerChecker<uint32_t>()))
             .AddAttribute(
                 "Aifsn",
@@ -101,8 +101,8 @@
                 "The values of AIFSN for all the links",
                 TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
                 AttributeContainerValue<UintegerValue>(),
-                MakeAttributeContainerAccessor<IntegerValue, std::list>(&Txop::SetAifsns,
-                                                                        &Txop::GetAifsns),
+                MakeAttributeContainerAccessor<UintegerValue, std::list>(&Txop::SetAifsns,
+                                                                         &Txop::GetAifsns),
                 MakeAttributeContainerChecker<UintegerValue>(MakeUintegerChecker<uint8_t>()))
             .AddAttribute("TxopLimit",
                           "The TXOP limit: the default value conforms to non-QoS "
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/vht/vht-phy.cc ns-3.38/src/wifi/model/vht/vht-phy.cc
--- ns-3.37/src/wifi/model/vht/vht-phy.cc	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/vht/vht-phy.cc	2023-03-16 20:54:23.864869400 -0700
@@ -552,7 +552,7 @@
         {
         case WIFI_CHANLIST_PRIMARY: {
             // Start of a PPDU for which its power measured within the primary 20 MHz channel is at
-            // or above the CCA sensitivy threshold.
+            // or above the CCA sensitivity threshold.
             return m_wifiPhy->GetCcaSensitivityThreshold();
         }
         case WIFI_CHANLIST_SECONDARY:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/vht/vht-ppdu.cc ns-3.38/src/wifi/model/vht/vht-ppdu.cc
--- ns-3.37/src/wifi/model/vht/vht-ppdu.cc	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/vht/vht-ppdu.cc	2023-03-16 20:54:23.864869400 -0700
@@ -46,14 +46,47 @@
                false) // don't instantiate LSigHeader of OfdmPpdu
 {
     NS_LOG_FUNCTION(this << psdu << txVector << txCenterFreq << ppduDuration << band << uid);
+    SetPhyHeaders(txVector, ppduDuration);
+}
+
+void
+VhtPpdu::SetPhyHeaders(const WifiTxVector& txVector, Time ppduDuration)
+{
+    NS_LOG_FUNCTION(this << txVector << ppduDuration);
+
+#ifdef NS3_BUILD_PROFILE_DEBUG
+    LSigHeader lSig;
+    SetLSigHeader(lSig, ppduDuration);
+
+    VhtSigHeader vhtSig;
+    SetVhtSigHeader(vhtSig, txVector, ppduDuration);
+
+    m_phyHeaders->AddHeader(vhtSig);
+    m_phyHeaders->AddHeader(lSig);
+#else
+    SetLSigHeader(m_lSig, ppduDuration);
+    SetVhtSigHeader(m_vhtSig, txVector, ppduDuration);
+#endif
+}
+
+void
+VhtPpdu::SetLSigHeader(LSigHeader& lSig, Time ppduDuration) const
+{
     uint16_t length =
         ((ceil((static_cast<double>(ppduDuration.GetNanoSeconds() - (20 * 1000)) / 1000) / 4.0) *
           3) -
          3);
-    m_lSig.SetLength(length);
-    m_vhtSig.SetMuFlag(m_preamble == WIFI_PREAMBLE_VHT_MU);
-    m_vhtSig.SetChannelWidth(m_channelWidth);
-    m_vhtSig.SetShortGuardInterval(txVector.GetGuardInterval() == 400);
+    lSig.SetLength(length);
+}
+
+void
+VhtPpdu::SetVhtSigHeader(VhtSigHeader& vhtSig,
+                         const WifiTxVector& txVector,
+                         Time ppduDuration) const
+{
+    vhtSig.SetMuFlag(m_preamble == WIFI_PREAMBLE_VHT_MU);
+    vhtSig.SetChannelWidth(txVector.GetChannelWidth());
+    vhtSig.SetShortGuardInterval(txVector.GetGuardInterval() == 400);
     uint32_t nSymbols =
         (static_cast<double>(
              (ppduDuration - WifiPhy::CalculatePhyPreambleAndHeaderDuration(txVector))
@@ -61,14 +94,10 @@
          (3200 + txVector.GetGuardInterval()));
     if (txVector.GetGuardInterval() == 400)
     {
-        m_vhtSig.SetShortGuardIntervalDisambiguation((nSymbols % 10) == 9);
+        vhtSig.SetShortGuardIntervalDisambiguation((nSymbols % 10) == 9);
     }
-    m_vhtSig.SetSuMcs(txVector.GetMode().GetMcsValue());
-    m_vhtSig.SetNStreams(txVector.GetNss());
-}
-
-VhtPpdu::~VhtPpdu()
-{
+    vhtSig.SetSuMcs(txVector.GetMode().GetMcsValue());
+    vhtSig.SetNStreams(txVector.GetNss());
 }
 
 WifiTxVector
@@ -76,27 +105,75 @@
 {
     WifiTxVector txVector;
     txVector.SetPreambleType(m_preamble);
-    txVector.SetMode(VhtPhy::GetVhtMcs(m_vhtSig.GetSuMcs()));
-    txVector.SetChannelWidth(m_vhtSig.GetChannelWidth());
-    txVector.SetNss(m_vhtSig.GetNStreams());
-    txVector.SetGuardInterval(m_vhtSig.GetShortGuardInterval() ? 400 : 800);
-    txVector.SetAggregation(GetPsdu()->IsAggregate());
+
+#ifdef NS3_BUILD_PROFILE_DEBUG
+    auto phyHeaders = m_phyHeaders->Copy();
+
+    LSigHeader lSig;
+    if (phyHeaders->RemoveHeader(lSig) == 0)
+    {
+        NS_FATAL_ERROR("Missing L-SIG header in VHT PPDU");
+    }
+
+    VhtSigHeader vhtSig;
+    if (phyHeaders->RemoveHeader(vhtSig) == 0)
+    {
+        NS_FATAL_ERROR("Missing VHT-SIG header in VHT PPDU");
+    }
+
+    SetTxVectorFromPhyHeaders(txVector, lSig, vhtSig);
+#else
+    SetTxVectorFromPhyHeaders(txVector, m_lSig, m_vhtSig);
+#endif
+
     return txVector;
 }
 
+void
+VhtPpdu::SetTxVectorFromPhyHeaders(WifiTxVector& txVector,
+                                   const LSigHeader& lSig,
+                                   const VhtSigHeader& vhtSig) const
+{
+    txVector.SetMode(VhtPhy::GetVhtMcs(vhtSig.GetSuMcs()));
+    txVector.SetChannelWidth(vhtSig.GetChannelWidth());
+    txVector.SetNss(vhtSig.GetNStreams());
+    txVector.SetGuardInterval(vhtSig.GetShortGuardInterval() ? 400 : 800);
+    txVector.SetAggregation(GetPsdu()->IsAggregate());
+}
+
 Time
 VhtPpdu::GetTxDuration() const
 {
     Time ppduDuration = Seconds(0);
     const WifiTxVector& txVector = GetTxVector();
+
+    uint16_t length = 0;
+    bool sgi = false;
+    bool sgiDisambiguation = false;
+#ifdef NS3_BUILD_PROFILE_DEBUG
+    auto phyHeaders = m_phyHeaders->Copy();
+
+    LSigHeader lSig;
+    phyHeaders->RemoveHeader(lSig);
+    VhtSigHeader vhtSig;
+    phyHeaders->RemoveHeader(vhtSig);
+
+    length = lSig.GetLength();
+    sgi = vhtSig.GetShortGuardInterval();
+    sgiDisambiguation = vhtSig.GetShortGuardIntervalDisambiguation();
+#else
+    length = m_lSig.GetLength();
+    sgi = m_vhtSig.GetShortGuardInterval();
+    sgiDisambiguation = m_vhtSig.GetShortGuardIntervalDisambiguation();
+#endif
+
     Time tSymbol = NanoSeconds(3200 + txVector.GetGuardInterval());
     Time preambleDuration = WifiPhy::CalculatePhyPreambleAndHeaderDuration(txVector);
-    Time calculatedDuration =
-        MicroSeconds(((ceil(static_cast<double>(m_lSig.GetLength() + 3) / 3)) * 4) + 20);
+    Time calculatedDuration = MicroSeconds(((ceil(static_cast<double>(length + 3) / 3)) * 4) + 20);
     uint32_t nSymbols =
         floor(static_cast<double>((calculatedDuration - preambleDuration).GetNanoSeconds()) /
               tSymbol.GetNanoSeconds());
-    if (m_vhtSig.GetShortGuardInterval() && m_vhtSig.GetShortGuardIntervalDisambiguation())
+    if (sgi && sgiDisambiguation)
     {
         nSymbols--;
     }
@@ -107,12 +184,7 @@
 Ptr<WifiPpdu>
 VhtPpdu::Copy() const
 {
-    return Create<VhtPpdu>(GetPsdu(),
-                           GetTxVector(),
-                           m_txCenterFreq,
-                           GetTxDuration(),
-                           m_band,
-                           m_uid);
+    return Ptr<WifiPpdu>(new VhtPpdu(*this), false);
 }
 
 WifiPpduType
@@ -131,10 +203,6 @@
 {
 }
 
-VhtPpdu::VhtSigHeader::~VhtSigHeader()
-{
-}
-
 TypeId
 VhtPpdu::VhtSigHeader::GetTypeId()
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/vht/vht-ppdu.h ns-3.38/src/wifi/model/vht/vht-ppdu.h
--- ns-3.37/src/wifi/model/vht/vht-ppdu.h	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/vht/vht-ppdu.h	2023-03-16 20:54:23.864869400 -0700
@@ -52,7 +52,6 @@
     {
       public:
         VhtSigHeader();
-        ~VhtSigHeader() override;
 
         /**
          * \brief Get the type ID.
@@ -165,10 +164,6 @@
             Time ppduDuration,
             WifiPhyBand band,
             uint64_t uid);
-    /**
-     * Destructor for VhtPpdu.
-     */
-    ~VhtPpdu() override;
 
     Time GetTxDuration() const override;
     Ptr<WifiPpdu> Copy() const override;
@@ -177,8 +172,48 @@
   private:
     WifiTxVector DoGetTxVector() const override;
 
+    /**
+     * Fill in the PHY headers.
+     *
+     * \param txVector the TXVECTOR that was used for this PPDU
+     * \param ppduDuration the transmission duration of this PPDU
+     */
+    virtual void SetPhyHeaders(const WifiTxVector& txVector, Time ppduDuration);
+
+    /**
+     * Fill in the L-SIG header.
+     *
+     * \param lSig the L-SIG header to fill in
+     * \param ppduDuration the transmission duration of this PPDU
+     */
+    virtual void SetLSigHeader(LSigHeader& lSig, Time ppduDuration) const;
+
+    /**
+     * Fill in the VHT-SIG header.
+     *
+     * \param vhtSig the VHT-SIG header to fill in
+     * \param txVector the TXVECTOR that was used for this PPDU
+     * \param ppduDuration the transmission duration of this PPDU
+     */
+    void SetVhtSigHeader(VhtSigHeader& vhtSig,
+                         const WifiTxVector& txVector,
+                         Time ppduDuration) const;
+
+    /**
+     * Fill in the TXVECTOR from PHY headers.
+     *
+     * \param txVector the TXVECTOR to fill in
+     * \param lSig the L-SIG header
+     * \param vhtSig the VHT-SIG header
+     */
+    void SetTxVectorFromPhyHeaders(WifiTxVector& txVector,
+                                   const LSigHeader& lSig,
+                                   const VhtSigHeader& vhtSig) const;
+
+#ifndef NS3_BUILD_PROFILE_DEBUG
     VhtSigHeader m_vhtSig; //!< the VHT-SIG PHY header
-};                         // class VhtPpdu
+#endif
+}; // class VhtPpdu
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-assoc-manager.cc ns-3.38/src/wifi/model/wifi-assoc-manager.cc
--- ns-3.37/src/wifi/model/wifi-assoc-manager.cc	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/wifi-assoc-manager.cc	2023-03-16 20:54:23.864869400 -0700
@@ -51,16 +51,15 @@
         return true;
     }
 
-    // the Compare method implemented by subclass may be such that the two ApInfo objects
-    // compare equal; in such a case, use the BSSID as tie breaker
     bool rhsBefore = m_manager.Compare(rhs, lhs);
     if (rhsBefore)
     {
         return false;
     }
 
-    WifiAddressHash hash;
-    return hash(lhs.m_bssid) > hash(rhs.m_bssid);
+    // the Compare method implemented by subclass may be such that the two ApInfo objects
+    // compare equal; in such a case, use the BSSID as tie breaker
+    return lhs.m_bssid < rhs.m_bssid;
 }
 
 TypeId
